#
# Copyright (c) 2003 LAAS/CNRS 
#
# Matthieu Herrb - Fri Dec  5 2003
#
# $Id: light.tcl,v 1.1 2003/12/05 21:36:32 matthieu Exp $
#
proc lightManager {} {
    global Gdhe::lights::position

    set w .lights
    toplevel $w
    wm title $w "Lights"
    
    scale $w.x -length 200 -label {X} -from -10 -to +10 -digits 3\
	-command "setLight x" -orient horizontal 
    set x [lindex $Gdhe::lights::position(LIGHT0) 0]
    puts "x $x"
    $w.x set $x
    scale $w.y -length 200 -label {Y} -from -10 -to +10 -digits 3\
	-command "setLight y" -orient horizontal
    $w.y set [lindex $Gdhe::lights::position(LIGHT0) 1]
    scale $w.z -length 200 -label {Z} -from -10 -to +10 -digits 3\
	-command "setLight z" -orient horizontal
    $w.z set [lindex $Gdhe::lights::position(LIGHT0) 2]
    checkbutton $w.on -text "Enable" \
        -variable  Gdhe::lights::enabled(LIGHT0)  -command setLights

    pack $w.x -fill x
    pack $w.y -fill x
    pack $w.z -fill x
    pack $w.on -fill x
}

proc setLight {axis value} {
    global Gdhe::lights::position

    set p $::Gdhe::lights::position(LIGHT0)
    switch -exact $axis {
	x { set q [ lreplace $p 0 0 $value ] }
	y { set q [ lreplace $p 1 1 $value ] }
	z { set q [ lreplace $p 2 2 $value ] }
    }
    # puts "setLight $axis $value -> $q"
    set Gdhe::lights::position(LIGHT0) $q
    # puts "  $::Gdhe::lights::position(LIGHT0)"
    setLights
    redrawAllWindows
}

proc showDir {l} {
    color 0 0 0
    polyline 2 0 0 0 \
	[lindex $Gdhe::lights::position($l) 0] \
	[lindex $Gdhe::lights::position($l) 1] \
	[lindex $Gdhe::lights::position($l) 2]
}
	
set robots(r1) atrv
set pos(r1) { 0 0 90 }

set robots(dir0) { showDir LIGHT0 }
set pos(dir0) { 0 0 0 }

set robots(rep) { color 0 150 0 ; repere 1 }
set pos(rep) { 0 0 0 }

