# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS: planet.tcl,v 1.4 2003/02/09 16:31:26 matthieu Exp $

package require Planet

set pos(LIGHT0) { 0 -4 0 }
set ambient(LIGHT0) { 0.1 0.1 0.1  }
set diffuse(LIGHT0) { 1 1 1 }
set enabled(LIGHT0) true

set enabled(LIGHT1) False

proc planet {name file} {
    global window
    global $window.$name

    if {![info exists $window.$name]} {
        pushMatrix
        translate 10 0 0
        set $window.$name [$window initPlanet $file]
        popMatrix
        puts "init"
    } else {
        drawPlanet 
    }
}

# Define obervator's distance
.gdhe.ogl.pos.dist set 40

set robots(terre) "planet earth $env(GDHE)/images/earth.xpm" 
# set robots(terre) "planet earth $env(GDHE)/images/earthcld.xpm"
set pos(terre) { 0 0 0 }


.gdhe.ogl redraw t

