/*
 * Copyright (C) 1996-2003 LAAS/CNRS 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */
/* $LAAS: global.h,v 1.13 2004/08/25 12:50:49 matthieu Exp $ */

#ifndef _GLOBAL_H
#define _GLOBAL_H

/**
 ** structure dfinissant un observateur GDHE 
 **/
#define PERSPECTIVE 0
#define ORTHOGONAL 1
#define CUSTOM 2

typedef struct GDHE_OBS {
    /* definition de l'observateur si viewMatMode == 0 */
    double dist;
    double elev;
    double azi;
    double x;
    double y;
    double z;
    int projMode; /* type de projection */
    double fovy; /* angle de champ de la projection */
    int viewMatMode; /* Mode de positionnement de l'operateur */
    double viewMat[16]; /* matrice de position de l'observateur si 
			   viewMatMode == 1 */
    double projMat[16]; /* Matrice de projection si projMode == CUSTOM */
} GDHE_OBS;

/**
 ** Dclaration des variables globales
 **/
extern Tcl_Obj *nullObj;

extern Tcl_HashTable *posTable;

extern float light_position[8][4];
extern int light_enabled[8];
extern int enable_lighting;

extern double xmin, ymin, zmin, xmax, ymax, zmax;
extern double backgroundColor[4];
extern int auto_redisplay;

extern int socket_serveur;
extern unsigned int FontBase;

extern void *tclInterp;

/**
 ** Macros gnrales
 **/
#define RAD_TO_DEG(x) ((x)*180/M_PI)

#endif
