# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS: film.tcl,v 1.7 2003/02/09 16:31:28 matthieu Exp $
#
# Exemple de generation de films MPEG a partir de GDHE
#
#
# Principe: film_window cree une fenetre aux dimensions de la sequence MPEG 
#            standard nommee film.ogl
#           ensuite la procedure film enchaine les operations
#
load ../lib/$env(MACHTYPE)-$env(OSTYPE)/mpeg2.so
source ../modules/mpeg2/MPEG1.tcl

proc film_window {} {
    global pos

    set w .film

    if ![winfo exists $w] {
	toplevel $w
	wm title $w "Film"

	togl $w.ogl -width 352 -height 288 -rgba true -double true \
	    -depth true -ident aux -sharelist main
	pack $w.ogl  -side left -padx 3 -pady 3 -fill both -expand t 
	
	addWindow $w.ogl
	setLights
    }
    # recupere le point de vue de la fenetre principale
    set l [.gdhe.ogl setObs]
    $w.ogl setObs -dist [lindex $l 0] -elev [lindex $l 1] \
	-azi [lindex $l 2] -x [lindex $l 3] -y [lindex $l 4] \
	-z [lindex $l 5]
    
}

set robots(h) { h2Clock }
set pos(h) {  -180 0 0 0 1 2 }

proc film {} {
    global pos robots


    .film.ogl mpegCaptureInit "test.mpg"

    for { set i 0 } {$i < 150} {incr i} {
	set pos(r1) "[expr -1.5 + 0.02*$i] 0 0"
	# puts $pos(r1)
	.film.ogl redraw t
	# .film.ogl dumpPpm -color /local/tmp/test.$i
	.film.ogl mpegCaptureFrame
	
    }
    mpegCaptureEnd
}
