# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS: grid.tcl,v 1.6 2003/02/09 16:31:28 matthieu Exp $
#----------------------------------------------------------------------
# dessin d'une grille 
package provide Gdhe::models 1.0

proc grille { xmin ymin xmax ymax pas } {
    
    pushMatrix 
    object Grille {
	# lignes 
	for { set x $xmin } { $x <= $xmax } { set x [expr $x + $pas] } {
	    polyline 2 $x $ymin 0 $x $ymax 0
	}
	# colonnes 
	for { set y $ymin } { $y <= $ymax } { set y [expr $y + $pas] } {
	    polyline 2 $xmin $y 0 $xmax $y 0
	}
    }
    popMatrix
}

proc carre { xmin ymin xmax ymax } {
    pushMatrix 
    object Carre {
	cullFace false
	color 100 255 0
	polygon 4 $xmin $ymin $xmax $ymin $xmax $ymax $xmin $ymax
    }
    popMatrix
}
